<?php
/*
Plugin Name: Facebook Page Photo Gallery
Plugin URI: http://zoxion.com/facebook-page-photo-gallery/
Description: This plugins embeds a Facebook Page Album into wordpress content. Just get the Album Id and use FB-Album[id] anywhere in your post
Author:  Freeman Chari
Version: 1.0.2
Author URI: http://www.zoxion.com
*/
if(class_exists('Services_JSON')){
include_once('json.php');}
add_action('wp_head', 'fb_embed_facebook_head');

define('FACEBOOK_PAGE_URL', get_option( 'siteurl' ). '/wp-content/plugins/facebook-page-photo-gallery');
// Define paths
define('FACEBOOK_PAGE_PATH', dirname(__FILE__));
define( 'FANCYBOX_VERSION', '1.3.4' );
define( 'MOUSEWHEEL_VERSION', '3.0.4' );
define( 'EASING_VERSION', '1.3' );

function fb_embed_facebook_head() {

	$settings = fppg_get_settings();

	$style= "<style>
	.error { border:1px solid #eee; background:#f9f9f9; padding:10px; margin-bottom:15px;}
	.fbbox { margin:0 0 25px 0; padding:0; font-weight:bold; font-size: 12px; text-shadow: 0px 1px 0px #FFF; line-height:18px; border: none;  }
	 .fbbox a, .fbbox a { color:#3B5998;text-decoration:none; }
	.fbbox a:hover, .fbbox a:hover { color:#3B5998;text-decoration:underline; }
	.fbboxhead { margin: 0;  font-size: 17px; border-bottom: none; background: transparent; height:20px; }
	.fbboxhead span { margin: 0; padding: 0px; font-size: 12px; }
	.fbboxbody { margin: 0; padding: 12px 10px 8px 10px; }
	.fbboxinfo { margin: 0 0 0 10px; padding: 10px; float:right; width:250px; border:1px solid #D8DFEA; background:#EDEFF4; tex-align:right; font-size:11px; }
        .fbMedThumb{ margin:3px;background:".$settings['thumbnailBgColor'].";border:".$settings['thumbnailBorder'].";padding:".$settings['thumbnailPadding']."px; vertical-align:bottom; box-shadow:".$settings['thumbnailShaddow'].";-moz-box-shadow:".$settings['thumbnailShaddow'].";-webkit-box-shadow:".$settings['thumbnailHeight'].";}
";

       $style .=" .fbthumb, .fbalbumpics .fbthumb {   width:".$settings['thumbnailWidth']."px; height:".$settings['thumbnailHeight']."px; }</style>\n";

       echo $style;
}    
 

add_filter('the_content', 'fb_embed_facebook');

/*
 * This function uses regular expression to find usage of the FB-Album[] code in content
 * @param $the_content the content to search
 * @return $the_content the content with replaced content
 *
 */

function fb_embed_facebook($the_content) {

	preg_match_all(" /\bFB-Album\[[0-9]*\]/", $the_content, $matches, PREG_SET_ORDER);
	
    foreach($matches as $match) {
    	$the_content = preg_replace(" /\bFB-Album\[[0-9]*\]/", fb_do_embed($match), $the_content, 1);
    }

	return $the_content;
}



/*
 * This function  can be called from within any template/theme page to
 * embed a facebook album
 * @param $albumid Facebook Album Id
 * @param $n  number of photos to show
 * @return html to embed the photos
 *
 */
function straight_embed_facebook($album_id,$n) {

    $the_content=limited_do_embed_new_album($album_id,$n);

	echo $the_content;
        return;
}

function fb_do_embed($id) {
	
	$albumid = explode('[', $id[0]);
	$albumid=substr($albumid[1],0, -1);
	if(!$albumid) {
		
		return fb_do_embed_profile($raw_query_string[0], $url[2]);

	} elseif($albumid) {
		
		
			return fb_do_embed_new_album($albumid);

        }else{
		
			return "<p><a href='".strip_tags($url[0])."' target='_blank'>".strip_tags($url[0])."</a></p>";
	}
}



/*
 * retrieve html of the facebook album to be embedded
 * @param $id Facebook Album Id
 *
 * @return html to embed the photos
 *
 */


function fb_do_embed_new_album($id) {
	
	

	$fb_photos = "http://graph.facebook.com/$id/photos?limit=100";
        $album="http://graph.facebook.com/$id";
        

//
				if (function_exists("curl_init")){
					$fb_photos = @curl_get_content($fb_photos);
                                $album = @curl_get_content($album);}
				else{
					$fb_photos = @file_get_contents($fb_photos);
                                        $album = @file_get_contents($album);}
				if(function_exists("json_decode")){
					$fb_photos = json_decode($fb_photos);
                                        $album = json_decode($album);}
				else{
					$fb_photos = _json_decode($fb_photos);
                                        $album =_json_decode($album);
                                }
				/*
				if(is_user_logged_in()) {
					print '<pre>';
					print_r($fb_photos);
					print '</pre>';
				}
				*/

				if(!isset($fb_photos->data)) {
					$return .= "<p><a href='http://www.facebook.com/$url'>www.facebook.com/$url</a></p>";

					if(is_user_logged_in())
						$return .= '<div class="error">Error: Couldn\'t access the photos inside the album. Please check privacy settings or contact me with album URL: <a href="http://abid.com/">abid.com</a><br />(this message is visible to logged in users only)</div>';
				} else {
                                    $return  = "<div class='fbbox'>\n";
				$return .= "<div class='fbboxhead'><span>By <a href='http://www.facebook.com/profile.php?id={$fb_photos->data[1]->from->id}' target='_blank'>{$fb_photos->data[1]->from->name}</a> &nbsp;|&nbsp; <a href='{$album->link}' target='_blank'>View on Facebook</a></span></div>\n";
				$return .= "<div class='fbboxbody'>\n";

					foreach($fb_photos->data as $key=>$photo) {
                                           
                                               $photo= $fb_photos->data[$key];
                                               //adjust_fb_photoname($photo->images[1]->source);
						$return .= "<a href='{$photo->source}' title='{$photo->name}'rel='gallery' style='display:inline-block'  class='fbMedThumb viewable'><i style='background:url(".check_thumbnail($photo->images[1]->source).") center 25% no-repeat;display:block ' class='fbthumb' style='border:1px solid #ccc; float:left;  ' ></i></a>";
                                        }
				}
				$return .= '<div class="clear"></div></div>';
				$return .= '</div>';





	return $return;
}


/*
 * Retrieve embeddable  html from facebook for a limited number of photos
 * This function cannot be called directly from a template/theme page
 * embed a facebook album
 * @param $albumid Facebook Album Id
 * @param $n  number of photos to show
 * @return html to embed the photos
 *
 */
 function limited_do_embed_new_album($albumid,$n) {
				$album="http://graph.facebook.com/$albumid";
				if($n)
					$fb_photos = "http://graph.facebook.com/{$albumid}/photos?limit=$n";
				else
					$fb_photos = "http://graph.facebook.com/{$albumid}/photos?limit=400";
if (function_exists("curl_init")){
					$fb_photos = @curl_get_content($fb_photos);
                                $album = @curl_get_content($album);}
				else{
					$fb_photos = @file_get_contents($fb_photos);
                                        $album = @file_get_contents($album);}
				if(function_exists("json_decode")){
					$fb_photos = json_decode($fb_photos);
                                        $album = json_decode($album);}
				else{
					$fb_photos = _json_decode($fb_photos);
                                        $album =_json_decode($album);
                                }
				
				if(!isset($fb_photos->data)) {
					$return .= "<p><a href='http://www.facebook.com/$url'>www.facebook.com/$url</a></p>";

					if(is_user_logged_in())
						$return .= '<div class="error">Error: Couldn\'t access the photos inside the album. Please check privacy settings or contact me with album URL: <a href="http://abid.com/">abid.com</a><br />(this message is visible to logged in users only)</div>';
				} else {
                                    $return  = "<div class='fbbox'>\n";
				$return .= "<div class='fbboxhead'><span>By <a href='http://www.facebook.com/profile.php?id={$fb_photos->data[1]->from->id}' target='_blank'>{$fb_photos->data[1]->from->name}</a> &nbsp;|&nbsp; <a href='{$album->link}' target='_blank'>View on Facebook</a></span></div>\n";
				$return .= "<div class='fbboxbody'>\n";
                               ;

foreach($fb_photos->data as $key=>$photo) {
    if($key<$n){ 

                                               $photo= $fb_photos->data[$key];
                                          
						$return .= "<a href='{$photo->source}' title='{$photo->name}'rel='gallery' style='display:inline-block'  class='fbMedThumb viewable'><i style='background:url(".check_thumbnail($photo->images[1]->source).") center 25% no-repeat;display:block ' class='fbthumb' style='border:1px solid #ccc; float:left;  ' ></i></a>";
                                       

                                       }
				}
                               
                                }
				$return .= '<div class="clear"></div></div>';
				$return .= '</div>';
                                
                                return $return;
}

function adjust_fb_photoname($old){

   $lastportion= substr($old, -5);
   $firstportion=substr($old,0,-5);

  $lastportion= substr_replace($lastportion, 'a', 0, 1);

  return $firstportion.$lastportion;
}

function check_thumbnail($photo){
    $lastportion= substr($photo, -5);
   if(substr($lastportion,1)=="a"){
       return $photo;
   }
   else{
       return adjust_fb_photoname($photo);
   }
}
function curl_get_content($url)
{
    $ch = curl_init();
	curl_setopt($ch, CURLOPT_USERAGENT, "Firefox (WindowsXP) - Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_HEADER, 0);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $return = ob_get_contents();
    ob_end_clean();
    return $return;    
}

function _json_encode($value) {
	$json = new Services_JSON();
	return $json->encode($value);
}

function _json_decode($value) {
	$json = new Services_JSON();
	return $json->decode($value);
}

function _iso8601($tstamp) {
	sscanf($tstamp,"%u-%u-%uT%u:%u:%uZ",$year,$month,$day,
	$hour,$min,$sec);
	$newtstamp=mktime($hour,$min,$sec,$month,$day,$year);
	return $newtstamp;
}


// When plugin is activated, update version, and set any new settings to default
function fppg_install() {

		update_option('active_version', '1.0');

                //options for the photos

                add_option('thumbnailWidth', '161'                );
                add_option('thumbnailHeight', '120'                );
                add_option('thumbnailBorder', '1px solid #ccc'                );
                add_option('thumbnailBgColor', '#FFFFFF'                );
                add_option('thumbnailPadding', '4'                );
                add_option('thumbnailShaddow', '1px 1px 5px #ccc'                );




		add_option('showTitle',					'on');

                add_option('titlePosition', 'outside');
		add_option('border',						'');
                add_option('cyclic',						'on');
		add_option('borderColor',				'#BBBBBB');
		add_option('closeHorPos',				'right');
		add_option('closeVerPos',				'top');
		add_option('paddingColor',			'#FFFFFF');
		add_option('padding',						'10');
		add_option('overlayShow',				'on');
		add_option('overlayColor',			'#666666');
		add_option('overlayOpacity',		'0.3');
		add_option('zoomOpacity',				'on');
		add_option('zoomSpeedIn',				'500');
		add_option('zoomSpeedOut',			'500');
		add_option('zoomSpeedChange',		'300');
		add_option('easing',						'');
		add_option('easingIn',					'easeOutBack');
		add_option('easingOut',					'easeInBack');
		add_option('easingChange',			'easeInOutQuart');

		add_option('imageScale',					'on');
		add_option('enableEscapeButton',	'on');
		add_option('showCloseButton',			'on');
		add_option('centerOnScroll',			'on');
		add_option('hideOnOverlayClick',	'on');
		add_option('hideOnContentClick',	'');
		add_option('loadAtFooter',				'');
		add_option('frameWidth',					'560');
		add_option('frameHeight',					'340');

		add_option('callbackOnStart',			'');
		add_option('callbackOnShow',			'');
		add_option('callbackOnClose',			'');

		add_option('galleryType',					'all');
		add_option('customExpression',		'jQuery(thumbnails).addClass("fancybox").attr("rel","fancybox").getTitle();');

		add_option('nojQuery',				'');
		add_option('jQnoConflict',		'on');

		add_option('uninstall',				'');

		// Settings, on previous versions, no longer used
		delete_option('autoApply');
		delete_option('closePosition');
		delete_option('noTextLinks');

}


// If requested, when plugin is deactivated, remove settings
function fppg_uninstall() {

	if (get_option('uninstall')){


		delete_option('active_version');
                delete_option('thumbnailWidth');
                delete_option('thumbnailHeight');
                delete_option('thumbnailBorder');
                delete_option('thumbnailBgColor');
                delete_option('thumbnailPadding');
                delete_option('thumbnailShaddow');
                delete_option('cyclic');
		delete_option('showTitle');
                delete_option('titlePosition');
		delete_option('border');
		delete_option('borderColor');
		delete_option('closeHorPos');
		delete_option('closeVerPos');
		delete_option('paddingColor');
		delete_option('padding');
		delete_option('overlayShow');
		delete_option('overlayColor');
		delete_option('overlayOpacity');
		delete_option('zoomOpacity');
		delete_option('zoomSpeedIn');
		delete_option('zoomSpeedOut');
		delete_option('zoomSpeedChange');
		delete_option('easing');
		delete_option('easingIn');
		delete_option('easingOut');
		delete_option('easingChange');

		delete_option('imageScale');
		delete_option('enableEscapeButton');
		delete_option('showCloseButton');
		delete_option('centerOnScroll');
		delete_option('hideOnOverlayClick');
		delete_option('hideOnContentClick');
		delete_option('loadAtFooter');
		delete_option('frameWidth');
		delete_option('frameHeight');

		delete_option('callbackOnStart');
		delete_option('callbackOnShow');
		delete_option('callbackOnClose');

		delete_option('galleryType');
		delete_option('customExpression');

		delete_option('nojQuery');
		delete_option('jQnoConflict');

		delete_option('uninstall');

	}

}


// Store plugin options in an array and return that array
function fppg_get_settings() {

	$SettingsArray=array(
                'thumbnailWidth'                            =>   get_option('thumbnailWidth'),
                'thumbnailHeight'                           =>   get_option('thumbnailHeight'),
                'thumbnailBorder'                          =>   get_option('thumbnailBorder' ),
                'thumbnailBgColor'                        =>   get_option('thumbnailBgColor'),
                'thumbnailPadding'                                            =>   get_option('thumbnailPadding'),
                'thumbnailShaddow'                                             =>   get_option('thumbnailShaddow' ),
		'version'						=> get_option('active_version'),
                'cyclic'                                        => get_option('cyclic'),
		'showTitle'					=> get_option('showTitle'),
		'titlePosition'                                 => get_option('titlePosition'),
                'border'						=> get_option('border'),
		'borderColor'				=> get_option('borderColor'),
		'closeHorPos'				=> get_option('closeHorPos'),
		'closeVerPos'				=> get_option('closeVerPos'),
		'paddingColor'			=> get_option('paddingColor'),
		'padding'						=> get_option('padding'),
		'overlayShow'				=> get_option('overlayShow'),
		'overlayColor'			=> get_option('overlayColor'),
		'overlayOpacity'		=> get_option('overlayOpacity'),
		'zoomOpacity'				=> get_option('zoomOpacity'),
		'zoomSpeedIn'				=> get_option('zoomSpeedIn'),
		'zoomSpeedOut'			=> get_option('zoomSpeedOut'),
		'zoomSpeedChange'		=> get_option('zoomSpeedChange'),
		'easing'						=> get_option('easing'),
		'easingIn'					=> get_option('easingIn'),
		'easingOut'					=> get_option('easingOut'),
		'easingChange'			=> get_option('easingChange'),

		'imageScale'						=> get_option('imageScale'),
		'enableEscapeButton'		=> get_option('enableEscapeButton'),
		'showCloseButton'				=> get_option('showCloseButton'),
		'centerOnScroll'				=> get_option('centerOnScroll'),
		'hideOnOverlayClick'		=> get_option('hideOnOverlayClick'),
		'hideOnContentClick'		=> get_option('hideOnContentClick'),
		'loadAtFooter'					=> get_option('loadAtFooter'),
		'frameWidth'						=> get_option('frameWidth'),
		'frameHeight'						=> get_option('frameHeight'),

		'callbackOnStart'				=> get_option('callbackOnStart'),
		'callbackOnShow'				=> get_option('callbackOnShow'),
		'callbackOnClose'				=> get_option('callbackOnClose'),

		'galleryType'						=> get_option('galleryType'),
		'customExpression'			=> get_option('customExpression'),

		'nojQuery'							=> get_option('nojQuery'),
		'jQnoConflict'					=> get_option('jQnoConflict'),

		'uninstall'							=> get_option('uninstall')

	);

	return $SettingsArray;

}

// Load FancyBox with the settings set
function do_fancybox() {

	$settings = fppg_get_settings();
      // print_r($settings);

	echo "\n"."\n"."<!-- Fancybox for WordPress v". $settings['version'] ." -->"."\n";

	?>

<script type="text/javascript">

	<?php if ($settings['jQnoConflict']) { ?>jQuery.noConflict();<?php } echo "\n" ?>


		// Now we call fancybox and apply it on any link with a rel atribute that starts with "fancybox", with the options set on the admin panel ?>


               
jQuery(document).ready(function($){
    $("a.viewable").fancybox({
                        'titleShow':<?php if ($settings['showTitle']) { echo "true"; } else { echo "false"; } ?>,
                        'cyclic':<?php if ($settings['cyclic']) { echo "true"; } else { echo "false"; } ?>,
                        'titlePosition':<?php echo '"'.$settings['titlePosition'].'"'?>,
			'padding': <?php echo $settings['padding']; ?>,
			'autoScale': <?php if ($settings['imageScale']) { echo "true"; } else { echo "false"; } ?>,
			'padding': <?php echo $settings['padding']; ?>,
			'opacity': <?php if ($settings['zoomOpacity']) { echo "true"; } else { echo "false"; } ?>,
			'speedIn': <?php echo $settings['zoomSpeedIn']; ?>,
			'speedOut': <?php echo $settings['zoomSpeedOut']; ?>,
			'changeSpeed': <?php echo $settings['zoomSpeedChange']; ?>,
			'overlayShow': <?php if ($settings['overlayShow']) { echo "true"; } else { echo "false"; } ?>,
			'overlayColor': <?php echo '"' . $settings['overlayColor'] . '"'; ?>,
			'overlayOpacity': <?php echo $settings['overlayOpacity']; ?>,
			'enableEscapeButton': <?php if ($settings['enableEscapeButton']) { echo "true"; } else { echo "false"; } ?>,
			'showCloseButton': <?php if ($settings['showCloseButton']) { echo "true"; } else { echo "false"; } ?>,
			'hideOnOverlayClick': <?php if ($settings['hideOnOverlayClick']) { echo "true"; } else { echo "false"; } ?>,
			'hideOnContentClick': <?php if ($settings['hideOnContentClick']) { echo "true"; } else { echo "false"; } ?>,
			'width':  <?php echo $settings['frameWidth']; ?>,
			'height':  <?php echo $settings['frameHeight']; ?>,
			<?php if ($settings['callbackOnStart']) { echo "'OnStart': ". $settings['callbackOnStart'] .","."\n"; } ?>
                        <?php if ($settings['callbackOnShow']) { echo "'OnComplete': ". $settings['callbackOnShow'] .","."\n"; } ?>
                        <?php if ($settings['callbackOnClose']) { echo "'OnClosed': ". $settings['callbackOnClose'] .","."\n"; } ?>
			'centerOnScroll': <?php if ($settings['centerOnScroll']) { echo "true"; } else { echo "false"; } ?>
                        <?php if ($settings['easing']) {?>,
			'easingIn': <?php echo '"' . $settings['easingIn'] . '"'; ?>,
			'easingOut': <?php echo '"' . $settings['easingOut'] . '"';} ?>



})
})

</script>
<?php echo "<!-- END Fancybox for WordPress -->"."\n";

}


// Load text domain
function fppg_admin_init() {
register_setting('fppg-options', 'showTitle');
                register_setting('fppg-options', 'thumbnailShaddow');
                register_setting('fppg-options', 'thumbnailPadding');
		register_setting('fppg-options', 'thumbnailBorder');
		register_setting('fppg-options', 'thumbnailBgColor');
		register_setting('fppg-options', 'thumbnailHeight');
		register_setting('fppg-options', 'thumbnailWidth');
		register_setting('fppg-options', 'showTitle');
                register_setting('fppg-options', 'titlePosition');
		register_setting('fppg-options', 'border');
		register_setting('fppg-options', 'borderColor');
		register_setting('fppg-options', 'closeHorPos');
		register_setting('fppg-options', 'closeVerPos');
		register_setting('fppg-options', 'paddingColor');
		register_setting('fppg-options', 'padding');
		register_setting('fppg-options', 'overlayShow');
		register_setting('fppg-options', 'overlayColor');
		register_setting('fppg-options', 'overlayOpacity');
		register_setting('fppg-options', 'zoomOpacity');
		register_setting('fppg-options', 'zoomSpeedIn');
		register_setting('fppg-options', 'zoomSpeedOut');
		register_setting('fppg-options', 'zoomSpeedChange');
		register_setting('fppg-options', 'easing');
		register_setting('fppg-options', 'easingIn');
		register_setting('fppg-options', 'easingOut');
		register_setting('fppg-options', 'easingChange');
		register_setting('fppg-options', 'imageScale');
		register_setting('fppg-options', 'centerOnScroll');
		register_setting('fppg-options', 'enableEscapeButton');
		register_setting('fppg-options', 'showCloseButton');
		register_setting('fppg-options', 'hideOnOverlayClick');
		register_setting('fppg-options', 'hideOnContentClick');
		register_setting('fppg-options', 'loadAtFooter');
		register_setting('fppg-options', 'frameWidth');
		register_setting('fppg-options', 'frameHeight');
		register_setting('fppg-options', 'callbackOnStart');
		register_setting('fppg-options', 'callbackOnShow');
		register_setting('fppg-options', 'callbackOnClose');
		register_setting('fppg-options', 'galleryType');
		register_setting('fppg-options', 'customExpression');
		register_setting('fppg-options', 'nojQuery');
		register_setting('fppg-options', 'jQnoConflict');
		register_setting('fppg-options', 'uninstall');

}
// Admin options page
function fppg_admin_menu() {

include_once FACEBOOK_PAGE_PATH . '/admin.php';

	$fppgadmin = add_submenu_page('options-general.php', 'Facebook Page Photo Gallery Options', 'Facebook Page Photo', 10, 'facebook-page-photo-gallery', 'fppg_options_page');
	
     

}
// Load Admin JS
function fppg_admin_head() {
    
	wp_enqueue_script('jquery-ui-tabs', array('jquery-ui-core')); // Load jQuery UI Tabs for Admin Page
	wp_enqueue_script('fancyboxadmin',FACEBOOK_PAGE_URL . '/fancybox/admin.js', array('jquery')); // Load specific JS for Admin Page
}
// ENQUEUE

add_action('admin_menu', 'fppg_admin_menu');     // Admin Panel Page
add_action('admin_init', 'fppg_admin_init');     // Register options
//add_action('wp_head', 'init');     // Register options

	// register main fancybox script
wp_enqueue_script('jquery.fancybox', FACEBOOK_PAGE_URL.'/fancybox/jquery.fancybox-'.FANCYBOX_VERSION.'.pack.js', array('jquery'), FANCYBOX_VERSION);
//wp_enqueue_script('jquery.easing', FACEBOOK_PAGE_URL.'/fancybox/jquery.easing-'.EASING_VERSION.'.pack.js', array('jquery'), EASING_VERSION);
wp_enqueue_script('jquery.mousewheel', FACEBOOK_PAGE_URL.'/fancybox/jquery.mousewheel-'.MOUSEWHEEL_VERSION.'.pack.js', array('jquery'), MOUSEWHEEL_VERSION);
wp_enqueue_style('fppg-fancybox.css', FACEBOOK_PAGE_URL.'/fppg-fancybox.css.php', false, FANCYBOX_VERSION, 'screen');
add_action('wp_head', 'do_fancybox');
add_action( "admin_menu", 'fppg_admin_head' );

// Install and Uninstall
register_activation_hook(__FILE__,'fppg_install');
register_deactivation_hook(__FILE__,'fppg_uninstall');

?>